* U_TROSYS  : Update new TRO SYS*.dbf's w/ file structure
*           : Tags & Index information w/ mfg dbf1 & dbf2 files
*           : Also uses existing O_Data, DCTFLD & TAGINFO files
*           : to fill in needed information for the new TRO 
*           : SYS*.dbf data dictionary files
*
*  Notes    : uses parts of l_finfo.prg (list file info)
*           : and is hardcoded for the mfg directories \mfg\dbf1 & \dbf2
*           : as well as the user temp files in \FOXMFG
*           :
*           : Uses my id from O_users
*           : I had already added a field "File_descr" to O_Data
*           : which is essentially same as the Systab.Promptname field
*           : And a passive dictionary "DCTFLD" which has prompt & other
*           : field or "column" data
*           : All my "file maintenance" screens [at least the first page]
*           : are named
*           : "S_"+ the file name which is always 6 characters long
*           : 
*  Purpose  : Create "column" & "table" info for all my .dbf's 
*           : in the new TRO data dictionary file format
*           : so I can replace use of O_data & use new rel of TRO
*           :  I will still have to create manually 
*           : the sysdom,sysfil,& syskey information
*
************************************************************************
PRIVATE ALL LIKE q_*,i,ii,j
STORE 0 TO i,j,ii
SET TALK OFF

  * Make sure input files are open & indexed properly
CLOSE DATABASES
SELECT 4
USE SYS(5)+"\MFG\DCTFLD.DBF" EXCLUSIVE
SET ORDER TO FIELD_NAME
SELECT 5
USE SYS(5)+"\MFG\O_DATA.DBF" EXCLUSIVE
SET ORDER TO FILE_NAME
SELECT 7
USE SYS(5)+"\MFG\SYSCOL.DBF" EXCLUSIVE   && Updated
SELECT 8
USE SYS(5)+"\MFG\SYSIND.DBF" EXCLUSIVE   && Updated
SELECT 9
USE SYS(5)+"\MFG\SYSTAB.DBF" EXCLUSIVE   && Updated
SET ORDER TO TAG TABLENAME
  
  * Get my user id & today's date & time
SELECT 10
USE SYS(5)+"\MFG\O_USERS.DBF"
q_user_id = O_users.User_id
USE
q_date = DATE()
q_time = VAL(SYS(2))

  * Loop through all three directories via "ii"

FOR ii = 1 TO 3
   
   DO CASE
      CASE ii = 1  && Update Mfg related files
         SET DEFAULT TO SYS(5)+"\MFG\DBF1"
         dir_path = SYS(5)+"\MFG\DBF1"
      CASE ii = 2  && Update Accounting related files
         SET DEFAULT TO SYS(5)+"\MFG\DBF2"
         dir_path = SYS(5)+"\MFG\DBF2"
      CASE ii = 3  && Update Temp/Work related files
         SET DEFAULT TO SYS(5)+"\FOXMFG"
         dir_path = SYS(5)+"\FOXMFG"
   ENDCASE
   
   	* Place names of all .dbf files into a work array
   
   q_lookfor  = dir_path+"\*.DBF"	
   q_numfiles = ADIR(q_files,(q_lookfor))
   =ASORT(q_files)
   
   IF q_numfiles = 0
	WAIT WINDOW  "No .dbf Files were found in "+ dir_path
	LOOP  && go to next directory
   ENDIF


   * Loop through each file in this directory
 
   FOR i = 1 TO q_numfiles

	  SELECT 1   && Open File i in work area 1
	  USE (dir_path+"\"+q_files[i,1])
	
	
		    * capture file related information
		    
	  q_fil_name = STRIPEXT(q_files[i,1])  && From FoxPro 2.0
	  q_fil_size = q_files[i,2]            && size of file
      q_fil_date = q_files[i,3]            && file DOS date stamp
      q_fil_time = q_files[i,4]            && file DOS time stamp
      q_fil_attr = q_files[i,5]            && file DOS attributes
         
      IF !SEEK(q_fil_name,"SYSTAB") AND NOT q_fil_name == "T_WORK"
         
         * Not in systab, so add file using O_data information

* Table/file information add [SYSTAB]
         
         IF SEEK(q_fil_name,"O_Data")
         
            SELECT O_data
            SCATTER MEMO MEMVAR
            IF EMPTY(m.file_alias)
               m.file_alias = m.file_name
            ENDIF
            
            INSERT INTO systab;
              (Aliasname,Aliasid,Tablename,;
               Tabletype,Filename,Promptname,;
               Valtabname,screenname,Pathtype,;
               Detail,Sysstatus,Runstatus,;
               Isagain,Isexclusiv,Orderby,;
               Reusecol,User_id,Createdate,;
               Createtime,Refdate,Reftime);
             VALUES;
              (m.file_alias,m.short_name,m.File_name,;
               "D",q_fil_name+".DBF",m.File_descr,;
               "","S_"+m.File_name,m.Path_type,;
               m.Notes,"","",;
               m.is_again,m.is_exclu,m.Order_tag,;
               m.Reuse_key,q_user_id,q_date,q_time,;
		          q_date,q_time)
		   
		 ENDIF
		         
	       
	        * Capture structure
	      
		* Get all index tag information
				
	     FOR j = 1 TO 75   && To highest conceivable num of tags
	    
	        SELECT 1   && select file q_file[i,1]
	    
		    IF TAG(j)==""   && no more tags exist
			   * Leave j loop now
			   EXIT 
            ENDIF
		
		    q_tag_name = TAG(j)
		    q_tag_num  = j
		    q_tag_expr = SYS(14,j)
		    q_tag_filter = SYS(2021,j)
		    q_prompt_name = IIF(SEEK(q_tag_name,"DCTFLD");
		                      ,dctfld.Field_prom,"")
		
	    
* INDEX TAGS : [SYSIND.dbf ]

			* Add one record per Tag found
			* Assumes all are .CDX Ascending Tags
			* (only ones I use at the moment)
			
		    INSERT INTO sysind ;
		       (Tablename,Indexname,Tagname,;
		         Promptname,Filename,Indextype,;
		         Detail,Expkey,Expfor,Orderdir,;
		         Sysstatus,Runstatus,Isunique,;
		         User_id,Createdate,Createtime,;
		         Refdate,Reftime);
		       VALUES;
		        (q_fil_name,q_fil_name,q_tag_name,;
		          q_prompt_name,q_fil_name+".CDX","T",;
		          "",q_tag_expr,q_tag_filter,"A",;
		          "","",.F.,;
		          q_user_id,q_date,q_time,;
		          q_date,q_time)
		   
		
				
	      ENDFOR  && j loop [Tag loop]
	
* get file structure & put into work file
	    
	      COPY STRUCTURE EXTENDED TO t_work.dbf
	      SELECT 2
          USE t_work EXCLUSIVE

* Process fields (Columns) [SYSCOL]

	      q_col_pos = 0  && counter for column position
	      SCAN
	
	         SCATTER MEMVAR
	         IF SEEK(m.field_name,"DCTFLD")
	            q_prompt = dctfld.field_prompt
	         ELSE
	            q_prompt = ""
	         ENDIF
	  
	         IF RIGHT(TRIM(m.field_name),2)=="ID" && If an id field
	            q_detail   = IIF(LEFT(m.field_name,6)=q_fil_name,;
		        "m.O_blankID","")
		     ELSE
		        q_detail = ""
	         ENDIF
	         
	         q_col_pos = q_col_pos + 1
	  
	         INSERT INTO syscol;
	          (Tablename,Columnname,Promptname,;
	            Columntype,Columnlen,;
	            Columndec,Gentype,Detail,;
	            Columnpos,User_id,Createdate,;
	            Createtime,Refdate,Reftime) ;
	         VALUES ;
	           (q_fil_name,m.field_name,q_prompt,;
	             field_type,field_len,;
	             field_dec,"",q_detail,;
	             q_col_pos,q_user_id,q_date,;
	             q_time,q_date,q_time)	
	
	
	      ENDSCAN  && End processing of fields
	
	      ZAP  && Clear work file
	      USE  && Close work file

      ENDIF !SEEK(q_file_name,"SYSTAB")
	    		    	
   ENDFOR	&& i loop (File Loop)

ENDFOR  && ii = 1 TO 3 (Directory Loop)

   * Make sure my "paths" in systab match those in O_Data:
   * For files in systab (O_*) which were not updated above
   
SELECT systab
SCAN FOR LEFT(systab.Tablename,2)="O_"
  IF SEEK(systab.Tablename,"O_Data")
     REPLACE systab.Pathtype WITH O_Data.Path_type
  ENDIF
ENDSCAN

* THIS LAST SECTION - OPTIONAL
*
* Sort my newly updated files in primary key order
*
SELECT SYSTAB
SORT TO D:\MFG\STAB.DBF ON SYSTAB.TABLENAME 
SELECT SYSIND
SORT TO D:\MFG\SIND.DBF ON SYSIND.TABLENAME,SYSIND.TAGNAME
SELECT SYSCOL
SORT TO D:\MFG\SCOL.DBF ON SYSCOL.TABLENAME,SYSCOL.COLUMNPOS  
CLOSE DATABASES
DELETE FILE SYSTAB.DBF
DELETE FILE SYSTAB.FPT
RENAME STAB.DBF TO SYSTAB.DBF
RENAME STAB.FPT TO SYSTAB.FPT
DELETE FILE SYSIND.DBF
DELETE FILE SYSIND.FPT
RENAME SIND.DBF TO SYSIND.DBF
RENAME SIND.FPT TO SYSIND.FPT
DELETE FILE SYSCOL.DBF
DELETE FILE SYSCOL.FPT
RENAME SCOL.DBF TO SYSCOL.DBF
RENAME SCOL.FPT TO SYSCOL.FPT
SELECT 7
USE SYS(5)+"\MFG\SYSCOL.DBF" EXCLUSIVE 
SET INDEX TO SYS(5)+"\MFG\SYSCOL.CDX"
REINDEX
SELECT 8
USE SYS(5)+"\MFG\SYSIND.DBF" EXCLUSIVE 
SET INDEX TO SYS(5)+"\MFG\SYSIND.CDX"
REINDEX
SELECT 9
USE SYS(5)+"\MFG\SYSTAB.DBF" EXCLUSIVE 
SET INDEX TO SYS(5)+"\MFG\SYSTAB.CDX"
REINDEX
*
* Now we're done
* eof
*!*********************************************************************
*!
*!      Procedure: STRIPEXT
*!
*!      Called by: IDLEREAD.PRG                  
*!
*!*********************************************************************
*
* STRIPEXT - Strip the extension from a file name.
*
* Description:
* Use the algorithm employed by FoxPRO itself to strip a
* file of an extension (if any): Find the rightmost dot in
* the filename.  If this dot occurs to the right of a "\"
* or ":", then treat everything from the dot rightward
* as an extension.  Of course, if we found no dot,
* we just hand back the filename unchanged.
*
* Parameters:
* filename - character string representing a file name
*
* Return value:
* The string "filename" with any extension removed
*
FUNCTION stripext
PARAMETER m.filename
PRIVATE m.dotpos, m.terminator
m.dotpos = RAT(".", m.filename)
m.terminator = MAX(RAT("\", m.filename), RAT(":", m.filename))
IF m.dotpos > m.terminator
	m.filename = LEFT(m.filename, m.dotpos-1)
ENDIF
RETURN m.filename
